/*
 *	app.h
 *
 *	USB-LAN (pingv)
 *
 *	* Sat Aug 27 17:04:00 JST 2005 Naoyuki Sawa
 *	- 1st [XB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	20			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

#define QUICK_REPEAT_PADS	(PAD_A | PAD_B)
#define QUICK_REPEAT_DELAY	SEC(0.5)

void app_init();
void app_exit();
int app_notify(int type, int param);
void schedule();
void delay(int frame);
void app_main();

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
